# $Revision: 1.72.BL $, $Date: 2008/08/30 21:09:47 $
#
# NOTE:
# - this is userspace for xen-3.2.0 (provided by kernel-xen.spec)
#   if you are looking for xen-3.0.2 (kernel.spec:LINUX_2_6_16), checkout
#   this spec from XEN_3_0_2 branch
#
# TODO:
# - pldized init scripts
# - script for rc-boot
#
# Conditional build:
%bcond_with	pae		# build with PAE (HIGHMEM64G) support
%bcond_with	hvm		# build with hvm (full virtualization) support
#
%define		major	3.3
%define		minor	0
%define         xen_min_version         3.0.4
Summary:	Xen - a virtual machine monitor
Summary(pl.UTF-8):	Xen - monitor maszyny wirtualnej
Name:		xen
Version:	%{major}.%{minor}
Release:	0.1BL1
License:	GPL
Group:		Applications/System
Source0:	http://bits.xensource.com/oss-xen/release/%{version}/%{name}-%{version}.tar.gz
Source1:	%{name}-xend.init
Source2:	%{name}-xendomains.init
Patch0:		%{name}-python_scripts.patch
Patch1:		%{name}-gcc.patch
Patch2:		%{name}-BL-3.1.patch
Patch3:		%{name}-python-path.patch
URL:		http://www.cl.cam.ac.uk/Research/SRG/netos/xen/index.html
%{?with_hvm:BuildRequires:	bcc}
BuildRequires:	curl-devel
BuildRequires:	e2fsprogs-devel
BuildRequires:	gcc >= 5:3.4
BuildRequires:	latex2html
BuildRequires:	libidn-devel
BuildRequires:	ncurses-devel
BuildRequires:	python-devel
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	tetex-dvips
BuildRequires:	tetex-format-latex
BuildRequires:	tetex-latex-psnfss
BuildRequires:	transfig
BuildRequires:	which
BuildRequires:	zlib-devel
Requires(post,preun):	/sbin/chkconfig
Requires:	%{name}-libs = %{version}-%{release}
Requires:	ZopeInterface
Requires:	bridge-utils
Requires:	coreutils
Requires:	diffutils
Requires:	gawk
Requires:	iptables
Requires:	kernel(xen0) >= %{xen_min_version}
Requires:	losetup
Requires:	net-tools
Requires:	python-%{name} = %{version}-%{release}
Requires:	rc-scripts
Requires:	sed
Requires:	util-linux
Requires:	which
Obsoletes:	xen-doc
ExclusiveArch:	%{ix86} %{x8664}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%ifnarch i686 athlon pentium3 pentium4
%undefine	with_pae
%endif

%description
This package contains the Xen hypervisor and Xen tools, needed to run
virtual machines on x86 systems, together with the kernel-xen*
packages. Information on how to use Xen can be found at the Xen
project pages.

Virtualisation can be used to run multiple versions or multiple Linux
distributions on one system, or to test untrusted applications in a
sandboxed environment. Note that the Xen technology is still in
development, and this RPM has received extremely little testing. Don't
be surprised if this RPM eats your data, drinks your coffee or makes
fun of you in front of your friends.

%description -l pl.UTF-8
Ten pakiet zawiera nadzorcę oraz narzędzia Xen, potrzebne do
uruchamiania wirtualnych maszyn w systemach x86, wraz z pakietami
kernel-xen*. Informacje jak używać Xena można znaleźć na stronach
projektu.

Wirtualizacja może być używana do uruchamiania wielu wersji lub wielu
dystrybucji Linuksa na jednym systemie lub do testowania nie zaufanych
aplikacji w odizolowanym środowisku. Należy zauważyć, że technologia
Xen jest ciągle rozwijana, a ten RPM był słabo testowany. Nie należy
być zdziwionym, jeśli ten pakiet zje dane, wypije całą kawę czy będzie
się wyśmiewał w obecności przyjaciół.

%package libs
Summary:	xen libraries
Summary(pl.UTF-8):	Biblioteki xena
Group:		Libraries

%description libs
xen libraries.

%description libs -l pl.UTF-8
Biblioteki xena.

%package devel
Summary:	Header files for xen
Summary(pl.UTF-8):	Pliki nagłówkowe xena
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Header files for xen.

%description devel -l pl.UTF-8
Pliki nagłówkowe xena.

%package static
Summary:	Static xen libraries
Summary(pl.UTF-8):	Statyczne biblioteki xena
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static xen libraries.

%description static -l pl.UTF-8
Statyczne biblioteki xena.

%package hotplug
Summary:	xen hotplug scripts
Summary(pl.UTF-8):	Skrypty hotplug dla xena
Group:		Application/System

%description hotplug
xen hotplug scripts.

%description hotplug -l pl.UTF-8
Skrypty hotplug dla xena.

%package udev
Summary:	xen udev scripts
Summary(pl.UTF-8):	Skrypty udev dla xena
Group:		Application/System

%description udev
xen udev scripts.

%description udev -l pl.UTF-8
Skrypty udev dla xena.

%package -n python-xen
Summary:	xen Python modules
Summary(pl.UTF-8):	Moduły Pythona dla xena
Group:		Libraries
Conflicts:	xen < 3.2.1-0.3

%description -n python-xen
xen Python modules.

%description -n python-xen -l pl.UTF-8
Moduły Pythona dla xena.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1


find '(' -name '*~' -o -name '*.orig' -o -name '.gitignore' ')' -print0 | xargs -0 -r -l512 rm -fv

%build
CFLAGS="%{rpmcflags} -I/usr/include/ncurses" \
CXXFLAGS="%{rpmcflags} -I/usr/include/ncurses" \
%{__make} -j1 xen tools \
	%{?with_pae:XEN_TARGET_X86_PAE=y} \
	CC=gcc4 \
	CXX="g++4"
#	CC="%{__cc}" \
#	CXX="%{__cxx}"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/var/run/{xen-hotplug,xend,xenstored}

%{__make} install-xen install-tools install-docs \
	CC=gcc4 \
	CXX="g++4" \
	%{?with_pae:XEN_TARGET_X86_PAE=y} \
	DESTDIR=$RPM_BUILD_ROOT \
	XEN_PYTHON_NATIVE_INSTALL=1
#	CC="%{__cc}" \
#	CXX="%{__cxx}" \

install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/xend
install %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/xendomains

install -d $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}/xend-db/{domain,vnet}
install -d $RPM_BUILD_ROOT%{_sharedstatedir}/xen/save

cp -a dist/install/etc/udev $RPM_BUILD_ROOT%{_sysconfdir}
cp -a dist/install/etc/hotplug $RPM_BUILD_ROOT%{_sysconfdir}

%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}

%py_postclean
# remove unneeded files
rm -f $RPM_BUILD_ROOT%{_includedir}/%{name}/COPYING
rm -rf $RPM_BUILD_ROOT%{_docdir}/xen
rm -rf $RPM_BUILD_ROOT%{_docdir}/qemu/qemu-doc.html
rm -rf $RPM_BUILD_ROOT/''etc/init.d
rm -f $RPM_BUILD_ROOT/boot/xen-3.2.gz
rm -f $RPM_BUILD_ROOT/boot/xen-3.gz
# strip - Unable to recognise the format of the input file 
rm -f $RPM_BUILD_ROOT%{_datadir}/xen/qemu/openbios-sparc32
rm -f $RPM_BUILD_ROOT%{_datadir}/xen/qemu/openbios-sparc64


# conflict with qemu
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/qemu-img.1
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/qemu.1

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add xend
/sbin/chkconfig --add xendomains

%preun
if [ "$1" = "0" ]; then
	%service xend stop
	/sbin/chkconfig --del xend

	%service xendomains stop
	/sbin/chkconfig --del xendomains
fi

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc COPYING README docs/misc/*
%doc docs/html/*
/boot/%{name}-syms-%{version}
/boot/%{name}-%{version}.gz
/boot/%{name}.gz
%attr(754,root,root) /etc/rc.d/init.d/*
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/*
%dir %{_sysconfdir}/xen
%attr(755,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/qemu-ifup
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/*.*
#%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/b*
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/xmexample[123]
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/README
%dir %{_sysconfdir}/xen/auto
%dir %{_sysconfdir}/xen/scripts
%attr(755,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/xen/scripts/*
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_sbindir}/*
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/bin
%attr(744,root,root) %{_libdir}/%{name}/bin/*
%if "%{_lib}" != "lib"
%dir %{_prefix}/lib/%{name}
%endif
%dir %{_prefix}/lib/%{name}/boot
%{?with_hvm:%attr(744,root,root) %{_prefix}/lib/%{name}/boot/hvmloader}
%{_datadir}/xen
%{_mandir}/man?/*
%{_sharedstatedir}/xen
%{_sharedstatedir}/xenstored
%dir /var/run/xen-hotplug
%dir %attr(700,root,root) /var/run/xend
%dir /var/run/xenstored

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/lib*.so.*
%dir %{_libdir}/fs
%dir %{_libdir}/fs/ext2fs-lib
%dir %{_libdir}/fs/fat
%dir %{_libdir}/fs/iso9660
%dir %{_libdir}/fs/reiserfs
%dir %{_libdir}/fs/ufs
%attr(755,root,root) %{_libdir}/fs/*/*.so

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/lib*.so
%{_includedir}/*

%files static
%defattr(644,root,root,755)
%{_libdir}/lib*.a

%if %{without hvm}
%files hotplug
%defattr(644,root,root,755)
%attr(755,root,root) /etc/hotplug/*
%endif

%files udev
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) /etc/udev/*

%files -n python-xen
%defattr(644,root,root,755)
%attr(755,root,root) %{py_sitedir}/fsimage.so
%{py_sitedir}/grub
%dir %{py_sitedir}/xen
%dir %{py_sitedir}/xen/lowlevel
%{py_sitedir}/xen/lowlevel/*.py*
%attr(755,root,root) %{py_sitedir}/xen/lowlevel/*.so
%{py_sitedir}/xen/sv
%{py_sitedir}/xen/util
%{py_sitedir}/xen/web
%{py_sitedir}/xen/xend
%{py_sitedir}/xen/xm
%{py_sitedir}/xen/xsview
%{py_sitedir}/xen/*.py*
%if "%{py_ver}" > "2.4"
%{py_sitedir}/*.egg-info
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: xen.spec,v $
Revision 1.72BL1  2008/10/24 17:52:24  bartoszl@ics.p.lodz.pl
- requires kernel(xen0) >= 3.0.4
- added brouter scripts

Revision 1.72  2008/08/30 21:09:47  wolvverine
- up to 3.3.0

Revision 1.71  2008/05/23 22:24:48  glen
- conflict before package split

Revision 1.70  2008-05-23 22:19:57  glen
- use util-linux dep

Revision 1.69  2008-05-11 19:30:20  glen
- spelling

Revision 1.68  2008-05-11 18:40:32  grzegorz
- hvmloader isn't built without bin86 which is req by bcc

Revision 1.67  2008-04-27 19:28:13  glen
- typo

Revision 1.66  2008-04-27 18:36:54  glen
- typo

Revision 1.65  2008-04-27 13:40:02  qboosh
- missing pl
- unified subpackages order: -devel/-static after -libs
- .so perms

Revision 1.64  2008-04-27 10:23:18  glen
- separate python modules
- remove also qemu docs

Revision 1.63  2008-04-27 10:10:55  glen
- epoch not defined, so don't use it

Revision 1.62  2008-04-27 10:09:50  glen
- remove conflicting manpages with qemu
- strict internal deps for -libs

Revision 1.61  2008-04-27 10:06:19  glen
- python packaging fixes (merge from XEN_3_0_2)

Revision 1.60  2008-04-26 21:12:35  glen
- install hotplug, avoid duplicate packaging

Revision 1.59  2008-04-26 16:19:24  glen
- pass CC also at install stage (used to check gcc version)

Revision 1.58  2008-04-26 15:42:04  glen
- update to 3.2.1, requires gcc >= 3.4

Revision 1.57  2008-02-29 12:28:47  arekm
- more R

Revision 1.56  2008-02-29 12:22:17  arekm
- R: gawk

Revision 1.55  2008-02-29 09:47:47  arekm
- fix/workaround build on x86_64 for now

Revision 1.54  2008-02-26 22:42:30  arekm
- final 3.2.0; lib64 systems need fix

Revision 1.53  2007-12-27 10:54:58  adamg
- updated to 3.2.0-rc4-pre; NFY

Revision 1.52  2007-04-20 20:58:04  qboosh
- added x8664 to EA (just builds on ac-amd64)

Revision 1.51  2007/04/20 09:55:30  qboosh
- separated -libs
- fs modules moved from -devel to -libs

Revision 1.50  2007/04/20 09:53:01  qboosh
- Twisted and libX11 are not used in this version

Revision 1.49  2007/04/19 22:55:08  qboosh
- use system libext2fs

Revision 1.48  2007/02/26 10:00:44  grzegorz
- added xen-blktap-no-aio-epoll.patch to allow tap:aio VBD
- rel 0.5

Revision 1.47  2007/02/12 22:09:22  glen
- tabs in preamble

Revision 1.46  2007/02/12 01:06:38  baggins
- converted to UTF-8

Revision 1.45  2007/02/10 22:42:19  alucard
- BR bin86 already needed by BR bcc...

Revision 1.44  2007/02/10 22:30:46  alucard
- BRs for hvm extensions

Revision 1.43  2007/02/10 17:33:59  alucard
- up to 3.0.4-1

Revision 1.42  2006/12/07 19:40:51  adamg
- unify pae bcond with kernel.spec

Revision 1.41  2006/11/25 23:40:07  shadzik
- don't try to package py_sitescriptdir which doesn't exist

Revision 1.40  2006/11/25 23:00:44  shadzik
- ups, re-add BR

Revision 1.39  2006/11/24 00:37:59  shadzik
- fix reisermodule build

Revision 1.38  2006/11/18 19:19:58  shadzik
- install missing dir /var/lib/xen/save and kill its duplicate in %file
- builds

Revision 1.37  2006/11/18 19:07:07  shadzik
- sed->tr (if you insit on using sed, give an apropriate BR)

Revision 1.36  2006/11/11 23:27:36  domelu
- missing dir /var/lib/xen/save

Revision 1.35  2006/11/01 13:08:42  grzegorz
- up to 3.0.3_0

Revision 1.34  2006/09/02 20:33:32  glen
- R(post): ldconfig

Revision 1.33  2006/08/19 13:05:23  adamg
- change Requires: kernel(xen) to Requires: kernel(xen0)

Revision 1.32  2006/07/26 14:19:03  adamg
- xen-xenstore-version.patch applied (fixes library soname)
- few more files added
- rel 0.3

Revision 1.31  2006/06/29 13:02:29  jajcus
- a patch added, which makes the bridge setup script work when the default route has 'onlink' attribute

Revision 1.30  2006/06/29 07:28:50  qboosh
- proper with_pae disabling

Revision 1.29  2006/06/29 06:30:46  jajcus
- enable PAE by default on archs supporting it

Revision 1.28  2006/06/28 08:28:58  jajcus
- with_pae bcond

Revision 1.27  2006/05/09 10:06:19  qboosh
- Obsoletes: xen-doc

Revision 1.26  2006/04/30 18:59:56  jajcus
- -doc subpackage removed, docs moved to %doc (a subpackage for a short
  documentation is overkill and installing documentation in %{_datadir} seems
  like a mistake)
- R: latex2html
- s,#!/bin/sh,#!/bin/bash, in many scripts -- they were written with Bash in mind
- s,#!/usr/bin/env python,#!/usr/bin/python, for all Python scripts
- Python scripts installed in %{py_scriptdir} and %{py_sitescriptdir}
- missing directories in /var/run added
- syms filename fixed
- many previously unpackaged files added to the package

Revision 1.25  2006/04/20 17:59:48  glen
- cosmetics

Revision 1.24  2006/04/20 17:58:55  glen
- use %service, add chkconfig deps

Revision 1.23  2006/04/19 12:26:42  cieciwa
- release 0.1,
- removed two patches
  Need more testing.

Revision 1.22  2006/04/19 12:12:39  cieciwa
- updated to version 3.0.2,
- requite kernel(xen)=%{_xen_version} - in this moment 3.0.2.

Revision 1.21  2005/09/01 17:27:03  paszczus
- real BR ; adapter removed it

Revision 1.20  2005/09/01 17:25:37  paszczus
- reverted (2.0.6 is back) cause linux-xen-2.0.6.patch needs update
- added BR: rpm-pythonprov
- adaptarized

Revision 1.16  2005/06/16 21:33:18  qboosh
- sorted deps

Revision 1.15  2005/06/16 21:15:29  speedy
- BR: which Req: bridge-utils

Revision 1.14  2005/06/13 12:45:34  speedy
- rel 0.3
- -scripts %patch

Revision 1.13  2005/06/12 22:38:32  speedy
- more and more...

Revision 1.12  2005/06/12 20:49:05  speedy
- Req: losetup

Revision 1.11  2005/06/12 18:24:54  speedy
- twisted.protocols.http has moved to twisted.web.http.
- missing directories

Revision 1.10  2005/06/10 11:53:08  speedy
- fixed BR

Revision 1.9  2005/06/10 10:01:41  speedy
- stable on HEAD, devel on DEVEL...
- version 2.0.6
- more BR

Revision 1.8  2005/04/20 14:24:36  paszczus
- updated to 20050420 snap
- changed Version number from 2 to 3 (this is 3.0-devel)
- builds.

Revision 1.7  2005/03/29 22:54:54  qboosh
- pl for -devel,-static; fixed -devel desc (what documentation?)

Revision 1.6  2005/03/29 16:27:04  arekm
- TODO: script for rc-boot

Revision 1.5  2005/03/29 16:25:32  arekm
- up to 20050329; add init scripts

Revision 1.4  2004/12/22 22:02:54  qboosh
- some files fixes (further needed), may require build/install fixes

Revision 1.3  2004/12/22 18:56:36  averne
- 755 for /etc/rc.d/init.d/xen*

Revision 1.2  2004/12/22 15:37:28  averne
- added BR: curl-devel, python-devel
- fixed to build

Revision 1.1  2004/12/22 14:37:25  arekm
- raw
